



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Python】解决测试依赖之 Mock模块的基本使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Python】解决测试依赖之 Mock模块的基本使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 20:03:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>什么是mock?</h2>
<p>Mock，顾名思义，模拟，在我们日常生活中或者影视作品中见得最多的可能就是预备飞行员的模拟训练，印象比较深的是电影《萨利机长》中的模拟器，经过几千次模拟，人们得出机长萨利在飞机遇到鸟群撞击后，作出了最符合当时情况的最正确的迫降决定，创造了奇迹。这里面涉及到的模拟就和我们今天所要讲的模拟类似，即用一个虚拟的对象来完成某些不容易构造或者不容易获取的对象或者场景的构造。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1172048/201807/1172048-20180708152917130-147109624.png"></p>
<h4>为什么要mock</h4>
<p>本文所讲的mock是mock测试，是辅助单元测试的一个模块。</p>
<p>实际生产中的项目是非常复杂的，对其进行单元测试的时候，可能会遇到以下问题：</p>
<ul><li>接口的依赖</li>
<li>外部接口调用</li>
<li>测试环境非常复杂</li></ul>
<p>单元测试应该只针对当前单元进行测试, 所有的内部或外部的依赖应该是稳定的, 已经在别处进行测试过的.使用mock 就可以对外部依赖组件实现进行模拟并且替换掉, 从而使得单元测试将焦点只放在当前的单元功能。</p>
<h4>安装使用</h4>
<p>在Python2.x中 mock是一个单独模块，需要单独安装。在Python3中 它已经被集成到了unitest模块可以直接会用<code>from unittest import mock</code>进行导入。当然，我们也可以使用如下命令独立安装。</p>
<pre class="prettyprint linenums"><code>pip install -U mock<br />
</code></pre>
<h2>简单的例子</h2>
<p>我们先从最简单例子开始。</p>
<pre class="prettyprint linenums"><code>#modular.py

class Count():

    def add(self):<br />
        pass<br />
</code></pre>
<p>这里要实现一个Count计算类，add()方法要实现两数相加。但这个功能我还没有完成。这时就可以借助mock对其进行测试。</p>
<pre class="prettyprint linenums"><code># mock_demo01.py

from unittest import mock<br />
import unittest

from modular import Count

# test Count class<br />
class TestCount(unittest.TestCase):

    def test_add(self):<br />
        count = Count()<br />
        count.add = mock.Mock(return_value=13)<br />
        result = count.add(8,5)<br />
        self.assertEqual(result,13)

if __name__ == '__main__':<br />
    unittest.main()<br />
</code></pre>
<p>首先实例化一个对象，调用被测试类Count() 。</p>
<pre class="prettyprint linenums"><code>count = Count()<br />
count.add = mock.Mock(return_value=7)<br />
</code></pre>
<p>通过Mock类模拟被调用的方法add()方法，return_value 定义add()方法的返回值。</p>
<pre class="prettyprint linenums"><code>result = count.add(2,5)<br />
</code></pre>
<p>接下来，相当于在正常的调用add()方法，传两个参数2和5，然后会得到相加的结果7。然后，7的结果是我们在上一步就预先设定好的。</p>
<pre class="prettyprint linenums"><code>self.assertEqual(result,7)<br />
</code></pre>
<p>最后，通过assertEqual()方法断言，返回的结果是否是预期的结果7。</p>
<p>运行测试结果：</p>
<pre class="prettyprint linenums"><code>&gt; python3 mock_demo01.py<br />
.<br />
----------------------------------------------------------------------<br />
Ran 1 test in 0.000s

OK<br />
</code></pre>
<p>这样一个用例就在mock的帮助下编写完成，并且测试通过了。</p>
<h4>完成功能测试</h4>
<p>再接下来完成module.py文件中add()方法。</p>
<pre class="prettyprint linenums"><code>#module.py

class Count():

    def add(self, a, b):<br />
        return a + b<br />
</code></pre>
<p>然后，修改测试用例：</p>
<pre class="prettyprint linenums"><code>from unittest import mock<br />
import unittest<br />
from module import Count

class MockDemo(unittest.TestCase):

    def test_add(self):<br />
        count = Count()<br />
        count.add = mock.Mock(return_value=13, side_effect=count.add)<br />
        result = count.add(8, 8)<br />
        print(result)<br />
        count.add.assert_called_with(8, 8)<br />
        self.assertEqual(result, 16)

if __name__ == '__main__':<br />
    unittest.main()<br />
</code></pre>
<pre class="prettyprint linenums"><code>count.add = mock.Mock(return_value=13, side_effect=count.add)<br />
</code></pre>
<p>side_effect参数和return_value是相反的。它给mock分配了可替换的结果，覆盖了return_value。简单的说，一个模拟工厂调用将返回side_effect值，而不是return_value。</p>
<p>所以，设置side_effect参数为Count类add()方法，那么return_value的作用失效。</p>
<pre class="prettyprint linenums"><code>result = count.add(8, 8)<br />
print(result)<br />
</code></pre>
<p>这次将会真正的调用add()方法，得到的返回值为16（8+8）。通过print打印结果。</p>
<pre class="prettyprint linenums"><code>assert_called_with(8,8)<br />
</code></pre>
<p>检查mock方法是否获得了正确的参数。</p>
<h2>解决测试依赖</h2>
<p>前面的例子，只为了让大家对mock有个初步的印象。再接来，我们看看如何mock方法的依赖。</p>
<p>例如，我们要测试A模块，然后A模块依赖于B模块的调用。但是，由于B模块的改变，导致了A模块返回结果的改变，从而使A模块的测试用例失败。其实，对于A模块，以及A模块的用例来说，并没有变化，不应该失败才对。</p>
<p>这个时候就是mock发挥作用的时候了。通过mock模拟掉影响A模块的部分（B模块）。至于mock掉的部分（B模块）应该由其它用例来测试。</p>
<pre class="prettyprint linenums"><code># function.py<br />
def add_and_multiply(x, y):<br />
    addition = x + y<br />
    multiple = multiply(x, y)<br />
    return (addition, multiple)

def multiply(x, y):<br />
    return x * y<br />
</code></pre>
<p>然后，针对 <code>add_and_multiply()</code>函数编写测试用例。func_test.py</p>
<pre class="prettyprint linenums"><code>import unittest<br />
import function

class MyTestCase(unittest.TestCase):

    def test_add_and_multiply(self):<br />
        x = 3<br />
        y = 5<br />
        addition, multiple = function.add_and_multiply(x, y)<br />
        self.assertEqual(8, addition)<br />
        self.assertEqual(15, multiple)

if __name__ == &quot;__main__&quot;:<br />
    unittest.main()<br />
</code></pre>
<p>运行结果：</p>
<pre class="prettyprint linenums"><code>&gt;  python3 func_test.py<br />
.<br />
----------------------------------------------------------------------<br />
Ran 1 test in 0.000s

OK<br />
</code></pre>
<p>目前运行一切正确常，然而，<code>add_and_multiply()</code>函数依赖了multiply()函数的返回值。如果这个时候修改multiply()函数的代码。</p>
<p>……</p>
<pre class="prettyprint linenums"><code>def multiply(x, y):<br />
    return x * y + 3<br />
</code></pre>
<p>这个时候，<code>multiply()</code>函数返回的结果变成了x*y加3。</p>
<p>再次运行测试：</p>
<pre class="prettyprint linenums"><code>&gt;  python3 func_test.py<br />
F<br />
======================================================================<br />
FAIL: test_add_and_multiply (__main__.MyTestCase)<br />
----------------------------------------------------------------------<br />
Traceback (most recent call last):<br />
  File &quot;fun_test.py&quot;, line 19, in test_add_and_multiply<br />
    self.assertEqual(15, multiple)<br />
AssertionError: 15 != 18                                                

----------------------------------------------------------------------<br />
Ran 1 test in 0.000s                                                    

FAILED (failures=1)<br />
</code></pre>
<p>测试用例运行失败了，然而，<code>add_and_multiply()</code>函数以及它的测试用例并没有做任何修改，罪魁祸首是multiply()函数引起的，我们应该把 multiply()函数mock掉。</p>
<pre class="prettyprint linenums"><code>import unittest<br />
from unittest.mock import patch<br />
import function

class MyTestCase(unittest.TestCase):

    @patch(&quot;function.multiply&quot;)<br />
    def test_add_and_multiply2(self, mock_multiply):<br />
        x = 3<br />
        y = 5<br />
        mock_multiply.return_value = 15<br />
        addition, multiple = function.add_and_multiply(x, y)<br />
        mock_multiply.assert_called_once_with(3, 5)

        self.assertEqual(8, addition)<br />
        self.assertEqual(15, multiple)

if __name__ == &quot;__main__&quot;:<br />
    unittest.main()<br />
</code></pre>
<p><code>@patch(&quot;function.multiply&quot;)``patch()</code>装饰/上下文管理器可以很容易地模拟类或对象在模块测试。在测试过程中，您指定的对象将被替换为一个模拟（或其他对象），并在测试结束时还原。</p>
<p>这里模拟function.py文件中multiply()函数。<code>def test_add_and_multiply2(self, mock_multiply):</code>在定义测试用例中，将<code>mock</code>的<code>multiply()</code>函数（对象）重命名为 <code>mock_multiply</code>对象。<code>mock_multiply.return_value = 15</code>设定<code>mock_multiply</code>对象的返回值为固定的15。<code>mock_multiply.assert_called_once_with(3, 5)</code> 检查ock_multiply方法的参数是否正确。</p>
<p>再次，运行测试用例，通过！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gj5w79.html">CI Weekly &num;3 &vert; 关于微服务、Docker 实践与 DevOps 指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv0zjj8.html">ToolBar 修改边距</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd5k178.html">C&num;（一维数组）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvorwxq.html">浅谈&period;prop&lpar;&rpar; 和 attr&lpar;&rpar; 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wzdrvq.html">DeDe内容调用img</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1xd479.html">DAO 基础学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd6grz8.html">ASP&period;NET文本框中添加日期选择控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mewwx2q.html">NancyFx 2&period;0的开源框架的使用-Stateless</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m062j8.html">CentOS下实用的网络管理工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z5em09.html">&period;Net Core小技巧 - 使用Swagger上传文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me34joq.html">Android远程桌面助手&lpar;Build 0787&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyg512q.html">ubuntu linux修改文件所属用户&lpar;owner属主&rpar;和组&lpar;groud属组、用户组&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyd1kv9.html">linux shell 杂</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o17gxeq.html">Win7 VS2013环境使用cuda&lowbar;7&period;5&period;18</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4jg6eq.html">解决eclipse中web项目出现Project facet Java version 1&period;8 is not supported&period;的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnnjwjq.html">LeetCode&colon; Balanced Binary Tree  解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/902e0dmq.html">LG2044 &lbrack;NOI2012&rsqb;随机数生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kgmxxq.html">Maven 使用 Nexus 内部库 代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e251j9.html">&lbrack;T-ARA&rsqb;&lbrack;Apple is A&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/953vo268.html">CDH5&period;2&plus;CM5&period;2&plus;impala2&plus;Spark1&period;1 集群搭建基础环境准备</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/902574jq.html">git下载和上传项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/963njgn9.html">问答项目---用户注册的那些事儿（JS验证）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvew5p19.html">Hadoop命令别名</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql10mr19.html">170807、intellij idea maven集成lombok实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k1jglq.html">oracle之用户名密码包含特殊字符时候怎么使用sqlplus登录</a>
			</li>
						<li><a href="https://www.batexi.com/a/9531gnz8.html">Chinese&lowbar;remainder&lowbar;theorem</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj42008.html">MTA---smtp&lpar;25&comma;postfix&comma;sendmail&rpar;&comma;Pop3&lpar;110&comma;Devocot&rpar;&comma;  MUA&lpar;foxmail&rpar; IMAP&lpar;server&comma;client rsync&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2gl3j8.html">日志汇总：logging、logger</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e1nnk9.html">一个Spark job的生命历程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlyn5z9.html">poj2954 Triangle</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
